<template>
  <div :id="id" :class="className" :style="{height:height,minWidth:width}" />
</template>

<script>
import echarts from 'echarts'
import resize from './mixins/resize'

export default {
  mixins: [resize],
  props: {
    className: {
      type: String,
      default: 'chart'
    },
    id: {
      type: String,
      default: 'chart'
    },
    title: {
      type: String,
      default: 'line'
    },
    width: {
      type: String,
      default: '500px'
    },
    height: {
      type: String,
      default: '400px'
    },
    lineData: {
      type: Object,
      default: () => {
        return {
          xAxis: [],
          series: []
        }
      }
    },
    description: {
      type: String,
      default: ''
    },
    config: {
      type: Object,
      default: () => {
        return {}
      }
    },
    format: {
      type: String,
      default: 'HH:mm:ss'
    },
    step: {
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      chart: null
    }
  },
  watch: {
    lineData: function(val) {
      this.updateChart(val)
    }
  },
  mounted() {
    this.initChart()
  },
  beforeDestroy() {
    if (!this.chart) {
      return
    }
    this.chart.dispose()
    this.chart = null
  },
  methods: {
    updateChart(data) {
      this.chart.setOption({
        xAxis: {
          data: data.xAxis
        },
        series: [{
          type: 'line',
          data: data.series
        }]
      })
    },
    initChart() {
      this.chart = echarts.init(document.getElementById(this.id))
      let config = {
        tooltip: {
          show: true
        },
        xAxis: {
          name: '频率',
          type: 'category',
          data: this.lineData.xAxis
        },
        yAxis: {
          name: '幅度',
          type: 'value'
        },
        series: [{
          type: 'line',
          showAllSymbol: 'auto',
          data: this.lineData.series
        }]
      }
      config = {
        ...config,
        ...this.config
      }

      this.chart.setOption(config)
    }
  }
}
</script>
